package javax.swing.text;

import java.io.Writer;
import java.io.Reader;
import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import javax.swing.Action;
import javax.swing.JEditorPane;
import java.io.Serializable;

public abstract class EditorKit implements Cloneable, Serializable
{
    public EditorKit() {
    }
    
    public Object clone() {
        Object clone;
        try {
            clone = super.clone();
        }
        catch (CloneNotSupportedException ex) {
            clone = null;
        }
        return clone;
    }
    
    public void install(JEditorPane editorPane) {
    }
    
    public void deinstall(JEditorPane editorPane) {
    }
    
    public abstract String getContentType();
    
    public abstract ViewFactory getViewFactory();
    
    public abstract Action[] getActions();
    
    public abstract Caret createCaret();
    
    public abstract Document createDefaultDocument();
    
    public abstract void read(InputStream p0, Document p1, int p2) throws IOException, BadLocationException;
    
    public abstract void write(OutputStream p0, Document p1, int p2, int p3) throws IOException, BadLocationException;
    
    public abstract void read(Reader p0, Document p1, int p2) throws IOException, BadLocationException;
    
    public abstract void write(Writer p0, Document p1, int p2, int p3) throws IOException, BadLocationException;
}
